using MongoDB.Bson;
using MongoDB.Bson.Serialization.Attributes;
using System.Text.Json.Serialization;

namespace Insight.Infrastructure.Entities
{
    [BsonIgnoreExtraElements]
    public class HostMemoryEntity
    {
        [BsonId, BsonRepresentation(BsonType.ObjectId), JsonPropertyName("id")]
        public string? Id { get; set; }

        [BsonElement("_host"), BsonRepresentation(BsonType.ObjectId), JsonPropertyName("host")]
        public string? Host { get; set; }

        [BsonElement("_batch"), BsonRepresentation(BsonType.ObjectId), JsonPropertyName("batch")]
        public string? Batch { get; set; }

        [BsonElement("insert")]
        public DateTime? Insert { get; set; }

        [BsonElement("update")]
        public DateTime? Update { get; set; }

        [BsonElement("index")]
        public uint? Index { get; set; }

        [BsonElement("company")]
        public string? Company { get; set; }

        [BsonElement("name")]
        public string? Name { get; set; }

        [BsonElement("tag")]
        public string? Tag { get; set; }

        [BsonElement("location")]
        public string? Location { get; set; }

        [BsonElement("serial")]
        public string? Serial { get; set; }

        [BsonElement("capacity")]
        public ulong? Capacity { get; set; }

        [BsonElement("clock")]
        public uint? Clock { get; set; }

        [BsonElement("clock_current")]
        public uint? CurrentClock { get; set; }

        [BsonElement("voltage")]
        public uint? Voltage { get; set; }

        [BsonElement("voltage_current")]
        public uint? CurrentVoltage { get; set; }
    }
}